; -------------------------------------------------------------
; 'STAR TIP 2' by TIM FOLLIN
; -------------------------------------------------------------
; Originally published in Your Sinclair issue #20 (August 1987)
; This version based on a disassembled Z88 conversion by P0KE
; (thanks for saving me typing in all the hex!)
; Adapted to TI-83 Plus by Ben Ryves
; -------------------------------------------------------------

#INCLUDE "ti83plus.inc"
.BINARYMODE TI8X

#DEFINE	BCALL(x) RST rBR_CALL \ .DW x

        .ORG	userMem - 2
        .DB		t2ByteTok, tasmCmp

		RET
		JR		NC,START

.DB		"'Star Tip 2' by Tim Follin",0

START:        
        LD      A,1
        LD      (penRow),A
        
        LD      HL,TEXT

TEXT_LOOP:

        LD      A,(HL)
        OR      A
        JR      Z,DONE_TEXT
        
        RES     fracDrawLFont,(IY+fontFlags)
        
        JP      P,SMALL_TEXT
        
        SET     fracDrawLFont,(IY+fontFlags)
        
        XOR     A
        LD      B,(HL)
LARGE_TEXT_SIZE:
        ADD     A,6
        DJNZ    LARGE_TEXT_SIZE
        
        JR      LARGE_TEXT

SMALL_TEXT:

        BCALL   (_SStringLength)

LARGE_TEXT:
        
        SRL     A
        NEG
        ADD     A,48
        
        LD      (penCol),A
        
        LD      B,(HL)
        RES     7,B
        INC     HL
        BCALL   (_vPutSN)
        
        LD      A,(penRow)
        ADD     A,8
        LD      (penRow),A
        
        JR TEXT_LOOP

DONE_TEXT:

        RES     fracDrawLFont,(IY+fontFlags)
        
        DI
        
        LD      A,FFh
        OUT     (1),A
        
        LD      A,FDh
        OUT     (1),A
        
        LD      HL,03E8h
        LD      (L9D5A),HL
        
        LD      IX,SONG_DATA

L9C40:  LD      A,(IX+00h)
        INC     A
L9C44:  JP      NZ,L9C71
        INC     IX
        LD      H,(IX+01h)
        LD      L,(IX+00h)
        
        LD      B,H
        LD      C,L
        SRL     B
        RR      C
        SRL     B
        RR      C
        SRL     B
        RR      C
        ADD     HL,BC
        
        LD      (LENGTH),HL
        INC     IX
        INC     IX
        LD      A,(IX+00h)
        LD      (L9D5C),A    
        LD      A,(IX+01h)
        LD      (L9D5A),A
        LD      A,(IX+02h)
        LD      (L9D5F),A
        INC     IX
        INC     IX
        INC     IX
        JP      L9C40

L9C71:  LD      A,(L9D5A)
        LD      (L9D5B),A     
        LD      A,(L9D5C)    
        LD      (L9D5D),A
        LD      BC,(LENGTH)
        LD      H,(IX+00h)
        LD      L,(IX+01h)
        LD      D,(IX+02h)
        LD      E,0Ah
        LD      A,01h
        LD      (L9D59),A
        LD      (L9D5E),A
        CALL    L9CB1
        XOR     A
        IN      A,(1)
        CPL
        AND     40h
        JP      NZ,L9CAD
        INC     IX
        INC     IX
        INC     IX
        LD      A,(IX+00h)
        AND     A
        JP      NZ,L9C40

L9CAD:  EI
        RET

        ; --- START PROC L9CB1 ---
L9CB1:  PUSH    BC
        NOP
        LD      A,(L9D59)
        NOP
        LD      C,A
        NOP
        DEC     H
        NOP
        JR      NZ,L9CCD
        NOP
        LD      A,D0LD1L
        NOP
        OUT     (bport),A
        NOP
        LD      B,C
L9CBE:  NOP
        DJNZ    L9CBE
        NOP
        LD      A,D0HD1H
        NOP
        OUT     (bport),A
        NOP
        LD      A,10h
        NOP
        SUB     C
        NOP
        LD      B,A
L9CC8:  NOP
        DJNZ    L9CC8
        NOP
        LD      H,(IX+00h)
L9CCD:  NOP
        DEC     L
        NOP
        JR      NZ,L9CE4
        NOP
        LD      A,D0LD1L
        NOP
        OUT     (bport),A
        NOP
        LD      B,C
L9CD5:  NOP
        DJNZ    L9CD5
        NOP
        LD      A,D0HD1H
        NOP
        OUT     (bport),A
        NOP
        LD      A,10h
        NOP
        SUB     C
        NOP
        LD      B,A
L9CDF:  NOP
        DJNZ    L9CDF
        NOP
        LD      L,(IX+01h)
L9CE4:  NOP
        DEC     D
        NOP
        JR      NZ,L9CFB
        NOP
        LD      A,D0LD1L
        NOP
        OUT     (bport),A
        NOP
        LD      B,C
L9CEC:  NOP
        DJNZ    L9CEC
        NOP
        LD      A,D0HD1H
        NOP
        OUT     (bport),A
        NOP
        LD      A,10h
        NOP
        SUB     C
        NOP
        LD      B,A
L9CF6:  NOP
        DJNZ    L9CF6
        NOP
        LD      D,(IX+02h)
L9CFB:  NOP
        DEC     E
        NOP
        JP      NZ,L9D4F
        NOP
        LD      E,0Ah
        NOP
        LD      A,(L9D5E)
        NOP
        AND     A
        NOP
        JP      Z,L9D2F
        NOP
        LD      A,(L9D5D)
        NOP
        DEC     A
        NOP
        LD      (L9D5D),A
        NOP
        JP      NZ,L9D4F
        NOP
        LD      A,(L9D5C)
        NOP
        LD      (L9D5D),A
        NOP
        LD      A,(L9D59)
        NOP
        INC     A
        NOP
        LD      (L9D59),A
        NOP
        CP      0Fh
        NOP
        JP      NZ,L9D4F
        NOP
        DEC     A
        NOP
        LD      (L9D59),A
        NOP
        XOR     A
        NOP
        LD      (L9D5E),A
        NOP
        JP      L9D4F

L9D2F:  NOP
        LD      A,(L9D5B)
        NOP
        DEC     A
        NOP
        LD      (L9D5B),A
        NOP
        JP      NZ,L9D4F
        NOP
        LD      A,(L9D5A)
        NOP
        LD      (L9D5B),A
        NOP
        LD      A,(L9D59)
        NOP
        DEC     A
        NOP
        LD      B,A
        NOP
        LD      A,(L9D5F)
        NOP
        CP      B
        NOP
        JP      Z,L9D4F
        NOP
        LD      A,B
        NOP
        LD      (L9D59),A
L9D4F:  NOP
        POP     BC
        NOP
        DEC     BC
        NOP
        LD      A,B
        NOP
        OR      C
        NOP
        JP      NZ,L9CB1
        NOP
        RET

;;;; variables

LENGTH: .EQU saveSScreen + 0
L9D58:  .EQU saveSScreen + 2
L9D59:  .EQU saveSScreen + 3
L9D5A:  .EQU saveSScreen + 4
L9D5B:  .EQU saveSScreen + 5
L9D5C:  .EQU saveSScreen + 6
L9D5D:  .EQU saveSScreen + 7
L9D5E:  .EQU saveSScreen + 8
L9D5F:  .EQU saveSScreen + 9
L9D60:  .EQU saveSScreen + 10
L9D61:  .EQU saveSScreen + 11

TEXT:
.DB		128+12,	"'Star Tip 2'"
.DB		128+13,	"by Tim Follin"
.DB		1,		" "
.DB		26,		"Published in Your Sinclair"
.DB		21,		"Issue #20 (Aug. 1987)"
.DB		1,		" "
.DB		27,		"Converted to the TI-83 Plus"
.DB		24,		"by Ben Ryves (Mar. 2023)"
.DB		0

;;;; tune

SONG_DATA:
.DB FFh, 60h, 09h, 02h, 01h, 0Ah, 41h, 52h, 6Dh, 3Dh, 52h, 6Dh, 41h, 52h, 6Dh, 49h
.DB 52h, 6Dh, FFh, 00h, 96h, 01h, 96h, 01h, 57h, 62h, 83h, FFh, 00h, 96h, FAh, 00h
.DB 0Fh, 57h, 62h, 83h, FFh, 60h, 09h, 04h, 01h, 0Ah, 53h, 5Dh, 7Ch, 46h, 5Dh, 7Ch
.DB 3Eh, 5Dh, 7Ch, 46h, 5Dh, 7Ch, 5Dh, 5Dh, 7Ch, 63h, 5Dh, 7Ch, 5Dh, 53h, 7Ch, 63h
.DB 53h, 7Ch, 6Eh, 53h, 7Ch, 7Ch, 53h, 7Ch, 8Ch, 53h, 7Ch, 7Ch, 53h, 7Ch, 6Fh, 53h
.DB 7Ch, 53h, 53h, 7Ch, FFh, 60h, 09h, 04h, 01h, 0Ah, 64h, 85h, C8h, 59h, 85h, C8h
.DB 54h, 85h, C8h, 42h, 84h, C7h, 54h, 85h, C8h, 59h, 85h, C8h, 64h, 85h, C8h, 70h
.DB 86h, C8h, 4Bh, 96h, E1h, 54h, 96h, E1h, 5Fh, 96h, E1h, 64h, 96h, E1h, 71h, 96h
.DB E1h, 7Fh, 97h, E1h, 71h, 96h, E1h, 64h, 96h, E1h, 4Eh, 9Dh, EBh, 58h, 9Dh, EBh
.DB 4Eh, 9Dh, EBh, 42h, 9Ch, EAh, 46h, 9Ch, EBh, 58h, 9Ch, EBh, 4Eh, 9Dh, EBh, 58h
.DB 9Dh, EBh, 4Eh, 9Dh, EBh, 63h, 9Dh, EBh, 69h, 9Dh, EBh, 84h, 9Dh, EBh, 76h, 9Dh
.DB EBh, 76h, 9Dh, EBh, 76h, 9Dh, EBh, 76h, 9Dh, EBh, 58h, 63h, C7h, 58h, 53h, C6h
.DB 57h, 41h, C5h, 57h, 37h, C3h, 58h, 63h, C7h, 58h, 53h, C6h, 57h, 41h, C5h, 57h
.DB 37h, C3h, 53h, 63h, C7h, 53h, 53h, C6h, 53h, 41h, C5h, 53h, 37h, C3h, 53h, 63h
.DB C7h, 53h, 53h, C6h, 53h, 41h, C5h, 53h, 37h, C3h, 63h, 63h, DFh, 63h, 5Eh, DFh
.DB 63h, 4Ah, DFh, 63h, 3Eh, DFh, 63h, 63h, DFh, 63h, 5Eh, DFh, 63h, 4Ah, DFh, 63h
.DB 3Eh, DFh, 5Dh, 63h, DFh, 5Dh, 5Eh, DFh, 5Dh, 4Ah, DFh, 5Dh, 3Eh, DFh, 5Dh, 63h
.DB DFh, 5Dh, 5Eh, DFh, 5Dh, 4Ah, DFh, 5Dh, 3Eh, DFh, 6Fh, 63h, C7h, 6Fh, 53h, C6h
.DB 6Fh, 41h, C5h, 6Fh, 37h, C3h, 84h, 63h, C7h, 84h, 53h, C6h, 84h, 41h, C5h, 84h
.DB 37h, C3h, 7Dh, 63h, DFh, 7Dh, 5Eh, DFh, 7Dh, 4Ah, DFh, 7Dh, 3Eh, DFh, 94h, 63h
.DB DFh, 94h, 5Eh, DFh, 94h, 4Ah, DFh, 94h, 3Eh, DFh, 84h, 63h, C7h, 84h, 53h, C6h
.DB 84h, 41h, C5h, 84h, 37h, C3h, 6Fh, 63h, C7h, 6Fh, 53h, C6h, 6Fh, 41h, C5h, 6Fh
.DB 37h, C3h, 63h, 63h, C7h, 63h, 53h, C6h, 63h, 41h, C5h, 63h, 37h, C3h, 63h, 63h
.DB C7h, 63h, 53h, C6h, 63h, 41h, C5h, 63h, 37h, C3h, 63h, 63h, C7h, 5Eh, 53h, C6h
.DB 63h, 41h, C5h, 5Eh, 37h, C3h, 63h, 63h, C7h, 5Eh, 53h, C6h, 63h, 41h, C5h, 5Eh
.DB 37h, C3h, 5Dh, 5Dh, D2h, 75h, 58h, D2h, 5Ch, 45h, CFh, 58h, 3Ah, D0h, 5Dh, 5Dh
.DB D2h, 75h, 58h, D2h, 5Ch, 45h, CFh, 58h, 3Ah, D0h, 5Dh, 5Dh, D2h, 75h, 58h, D2h
.DB 5Ch, 45h, CFh, 58h, 3Ah, D0h, 5Ch, 5Ch, 8Bh, 75h, 58h, 8Bh, 5Ch, 45h, 8Bh, 58h
.DB 3Ah, 8Bh, 63h, 63h, DEh, 63h, 5Eh, DEh, 63h, 4Ah, DDh, 62h, 3Eh, DCh, 63h, 63h
.DB DEh, 63h, 5Eh, DEh, 63h, 4Ah, 6Fh, 62h, 3Eh, DCh, 63h, 63h, 94h, 63h, 5Eh, F8h
.DB 63h, 4Ah, 94h, 62h, 3Eh, F8h, 63h, 63h, F8h, 63h, 5Eh, F8h, 63h, 4Ah, F8h, 62h
.DB 3Eh, F8h, FFh, 60h, 09h, 01h, 01h, 0Dh, 63h, 63h, F8h, 63h, 5Eh, F8h, 63h, 4Ah
.DB F8h, 62h, 3Eh, F8h, 63h, 63h, F8h, 63h, 5Eh, F8h, 63h, 4Ah, F8h, 62h, 3Eh, F8h
.DB 6Fh, 63h, F8h, 6Fh, 5Eh, F8h, 6Fh, 4Ah, F8h, 6Fh, 3Eh, F8h, 6Fh, 63h, F8h, 6Fh
.DB 5Eh, F8h, 6Fh, 4Ah, F8h, 6Fh, 3Eh, F8h, FFh, C0h, 12h, 01h, 01h, 0Dh, 4Ah, 59h
.DB DEh, 53h, 63h, DCh, 59h, 6Fh, DEh, 53h, 63h, DCh, 63h, 7Ch, F9h, 58h, 6Fh, F9h
.DB 4Ah, 58h, F9h, 58h, 6Fh, F9h, FFh, 60h, 09h, 01h, 01h, 0Dh, 57h, 68h, 83h, 68h
.DB 68h, 83h, 83h, 68h, 83h, 62h, 68h, 83h, 68h, 68h, 83h, 83h, 68h, 83h, 62h, 6Fh
.DB 94h, 6Fh, 6Fh, 94h, 94h, 6Fh, 94h, 58h, 6Fh, 94h, 6Fh, 6Fh, 94h, 94h, 6Fh, 94h
.DB 57h, 68h, 83h, 68h, 68h, 83h, 83h, 68h, 83h, 62h, 68h, 83h, 68h, 68h, 83h, 83h
.DB 68h, 83h, 62h, 6Fh, 94h, 6Fh, 6Fh, 94h, 94h, 6Fh, 94h, 76h, 6Fh, 94h, 6Fh, 6Fh
.DB 94h, 94h, 6Fh, 94h, FFh, 60h, 09h, 01h, 1Eh, 01h, 6Fh, 94h, DEh, 6Fh, 94h, DEh
.DB 6Fh, 94h, DEh, 6Fh, 94h, DEh, 7Dh, A6h, DEh, 6Fh, 94h, DEh, 7Dh, A6h, DEh, 6Fh
.DB 94h, DEh, 5Dh, 8Ch, DEh, 6Fh, 8Ch, DEh, 6Fh, 8Ch, DEh, 6Fh, 8Ch, DEh, 7Dh, 8Ch
.DB DEh, 6Fh, 8Ch, DEh, 5Dh, 8Ch, DEh, 6Fh, 8Ch, DEh, 53h, 7Ch, DEh, 63h, 7Ch, DEh
.DB 7Ch, 7Ch, DEh, 95h, 7Ch, DEh, 7Ch, 7Ch, DEh, 63h, 7Ch, DEh, 53h, 7Ch, DEh, 5Dh
.DB 7Ch, DEh, 63h, 7Ch, DEh, 7Ch, 7Ch, DEh, 6Fh, 6Fh, DEh, 6Fh, 6Fh, DEh, 6Fh, 6Fh
.DB DEh, 6Fh, 6Fh, DEh, 6Fh, 6Fh, DEh, 6Fh, 6Fh, DEh, 6Fh, 6Fh, DEh, 6Fh, 6Fh, DEh
.DB 6Fh, 6Fh, DEh, FFh, C0h, 12h, 01h, 00h, 00h, E0h, E1h, E2h, E0h, E1h, E2h, FFh
.DB 60h, 09h, 01h, 00h, 28h, 5Dh, 7Ch, 93h, E0h, E1h, E2h, E0h, E1h, E2h, 5Dh, 7Ch
.DB 93h, E0h, E1h, E2h, E0h, E1h, E2h, 5Dh, 7Ch, 93h, E0h, E1h, E2h, FFh, 80h, 25h
.DB 01h, 00h, 1Eh, 62h, 7Ch, A5h, FFh, 60h, 09h, 01h, 00h, 02h, 3Dh, 7Ah, B8h, 45h
.DB 6Eh, B8h, 49h, 7Ah, B8h, 36h, 6Dh, A3h, 3Dh, 61h, A3h, 41h, 6Dh, A3h, 3Dh, 7Ah
.DB B8h, 45h, 6Eh, B8h, 49h, 7Ah, B8h, 36h, 6Dh, A3h, 3Dh, 61h, A3h, 41h, 6Dh, A3h
.DB FFh, C0h, 12h, 01h, 00h, 28h, E0h, E1h, E2h, E0h, E1h, E2h, FFh, 60h, 09h, 01h
.DB 00h, 28h, 5Dh, 7Ch, 93h, E0h, E1h, E2h, E0h, E1h, E2h, 5Dh, 7Ch, 93h, E0h, E1h
.DB E2h, E0h, E1h, E2h, 5Dh, 7Ch, 93h, E0h, E1h, E2h, FFh, 80h, 25h, 01h, 00h, 1Eh
.DB 52h, 6Dh, 82h, FFh, 60h, 09h, 01h, 00h, 02h, 3Dh, 7Ah, B8h, 45h, 6Eh, B8h, 49h
.DB 7Ah, B8h, 36h, 6Dh, A3h, 3Dh, 61h, A3h, 41h, 6Dh, A3h, 45h, 8Ah, CFh, 4Eh, 7Ch
.DB CFh, 53h, 8Bh, D0h, 3Dh, 7Ah, B8h, 45h, 6Eh, B8h, 49h, 7Ah, B8h, 4Eh, 9Ch, EAh
.DB 58h, 8Ch, EAh, 5Eh, 9Dh, EBh, 45h, 8Ah, CFh, 4Eh, 7Ch, CFh, 53h, 8Bh, D0h, 3Dh
.DB 7Ah, B8h, 45h, 6Eh, B8h, 49h, 7Ah, B8h, 36h, 6Dh, A3h, 3Dh, 61h, A3h, 41h, 6Dh
.DB A3h, 30h, 60h, 90h, 36h, 56h, 90h, 39h, 60h, 90h, 36h, 56h, 90h, 30h, 60h, 90h
.DB 36h, 56h, 90h, 39h, 60h, 90h, 36h, 56h, 90h, 30h, 60h, 90h, 36h, 56h, 90h, 39h
.DB 60h, 90h, 36h, 56h, 90h, 30h, 60h, 90h, 36h, 56h, 90h, 39h, 60h, 90h, 36h, 56h
.DB 90h, FFh, 00h, 96h, 00h, 80h, 01h, 39h, 60h, 90h, 00h, 00h

.END
